CREATE TABLE tfc_estados (Id INT NOT NULL AUTO_INCREMENT,Nombre TEXT NOT NULL ,Habilitado INT(1) NOT NULL,  PRIMARY KEY (Id));

CREATE TABLE tfc_roles (Id INT NOT NULL AUTO_INCREMENT,Nombre TEXT NOT NULL ,Habilitado INT(1) NOT NULL,  PRIMARY KEY (Id));

CREATE TABLE tfc_departamento ( Id INT NOT NULL AUTO_INCREMENT,Nombre TEXT NOT NULL , Habilitado INT(1) NOT NULL, PRIMARY KEY (Id));

CREATE TABLE tfc_tipoIncidencias (Id INT  NOT NULL AUTO_INCREMENT, Nombre TEXT NOT NULL, IdPadre INT NOT NULL, IdDepartamento INT NOT NULL, Habilitado INT(1) NOT NULL, PRIMARY KEY (Id), FOREIGN KEY (IdDepartamento) REFERENCES tfc_departamento (Id)) ;
 
CREATE TABLE tfc_usuario (Id INT NOT NULL AUTO_INCREMENT, Nombre TEXT NOT NULL , Contrasena TEXT NOT NULL, Correo TEXT nOT NULL , Rol INT NOT NULL, Habilitado INT(1)NOT NULL, PRIMARY KEY (Id), FOREIGN KEY (Rol) REFERENCES tfc_roles (Id));

CREATE TABLE tfc_personal (Id INT NOT NULL AUTO_INCREMENT, IdUsuario INT NOT NULL , IdDepartamento INT NOT NULL, PRIMARY KEY (Id), FOREIGN KEY (IdUsuario) REFERENCES tfc_usuario (Id)) ;

CREATE TABLE tfc_incidencias (Id INT NOT NULL AUTO_INCREMENT, IdEstado INT NOT NULL, Asunto TEXT NOT NULL, Descripcion TEXT, FechaCreacion timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, FechaCierre timestamp NULL DEFAULT NULL, IdTipo INT NOT NULL, IdUsuario INT NOT NULL, IdDepartamento INT NOT NULL, IdGestor INT DEFAULT NULL, IdRelacion INT DEFAULT NULL, Habilitado INT(1) NOT NULL,  PRIMARY KEY (Id), FOREIGN KEY (IdEstado) REFERENCES tfc_estados (Id), FOREIGN KEY (IdTipo) REFERENCES tfc_tipoIncidencias (Id), FOREIGN KEY (IdUsuario) REFERENCES tfc_usuario (Id), FOREIGN KEY (IdDepartamento) REFERENCES tfc_departamento (Id)) ;

CREATE TABLE tfc_eventos (Id INT NOT NULL AUTO_INCREMENT, IdIncidencia INT NOT NULL, Descripcion TEXT NOT NULL, Fecha timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, IdGestor INT NOT NULL, Tipo TEXT NOT NULL, PRIMARY KEY (Id), FOREIGN KEY (IdIncidencia) REFERENCES tfc_incidencias (Id));


CREATE TABLE tfc_avisos (Id INT NOT NULL AUTO_INCREMENT, Descripcion TEXT NOT NULL, Estado INT NOT NULL, IdIncidencia INT NOT NULL, FechaCreacion timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP, FechaCierre timestamp NULL DEFAULT NULL, Habilitado INT(1) NOT NULL, PRIMARY KEY (Id), FOREIGN KEY (IdIncidencia) REFERENCES tfc_incidencias (Id));